import nacl from "ecma-nacl";

function encrypt_file(data, k, n) {
    data = new Uint8Array(data);
    k = new Uint8Array(k);
    n = new Uint8Array(n);

    const encrypted_data = nacl.secret_box.formatWN.pack(data, n, k);
    const encrypted_buffer = encrypted_data.buffer;

    self.postMessage({ kwargs: encrypted_buffer }, [encrypted_buffer]);
}

function decrypt_file(text, k) {
    text = new Uint8Array(text);
    k = new Uint8Array(k);

    const decrypted_data = nacl.secret_box.formatWN.open(text, k);
    let decrypted_buffer = decrypted_data.buffer;
    decrypted_buffer = decrypted_buffer.slice(32, decrypted_buffer.byteLength);

    self.postMessage({ kwargs: decrypted_buffer }, [decrypted_buffer]);
}

self.onmessage = function (msg) {
    switch (msg.data.job) {
        case "encrypt_file":
            encrypt_file(msg.data.kwargs.data, msg.data.kwargs.k, msg.data.kwargs.n);
            break;
        case "decrypt_file":
            decrypt_file(msg.data.kwargs.text, msg.data.kwargs.k);
            break;
        default:
            throw "job could not be handled: " + msg.data.job;
    }
};
